/* This file is part of the FaCT++ DL reasoner
Copyright (C) 2015 by Dmitry Tsarkov

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef ACTORBASE_H
#define ACTORBASE_H

class Taxonomy;
class TaxonomyVertex;

/// base class for taxonomy actors that provide necessary interface
// TODO!! Rename when the Walker interface will be used
class ActorBase
{
public:		// interface
		/// empty c'tor
	ActorBase ( void ) {}
		/// empty d'tor
	virtual ~ActorBase ( void ) {}

		/// taxonomy walking method.
		/// @return true if node was processed
		/// @return false if node can not be processed in current settings
	virtual bool apply ( const TaxonomyVertex& v ) = 0;
		/// filter out the indirect nodes
	virtual void filterIndirect ( Taxonomy*, bool ) {}

}; // ActorBase
